/*
Copyright © 2020 NAME HERE <EMAIL ADDRESS>

Licensed under the Apache License, Version 2.0 (the "License");
you may not use this file except in compliance with the License.
You may obtain a copy of the License at

    http://www.apache.org/licenses/LICENSE-2.0

Unless required by applicable law or agreed to in writing, software
distributed under the License is distributed on an "AS IS" BASIS,
WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
See the License for the specific language governing permissions and
limitations under the License.
*/
package cmd

import (
	"bytes"
	"fmt"
	"html/template"
	"net/smtp"

	"github.com/spf13/cobra"
)

type Request struct {
	from    string
	to      []string
	subject string
	body    string
}

var auth smtp.Auth

func (r *Request) SendEmail() (bool, error) {

	auth = smtp.PlainAuth("", "anothertest@indie.host", "YzYLCbQpkFLftKWn1GT2O65d", "mail.indie.host")

	mime := "MIME-version: 1.0;\nContent-Type: text/html; charset=\"UTF-8\";\n\n"
	subject := "Subject: " + r.subject + "!\n"
	msg := []byte(subject + mime + "\n" + r.body)
	addr := "mail.indie.host:587"

	if err := smtp.SendMail(addr, auth, "anothertest@indie.host", r.to, msg); err != nil {
		return false, err
	}
	return true, nil
}

func (r *Request) ParseTemplate(templateFileName string, data interface{}) error {
	t, err := template.ParseFiles(templateFileName)
	if err != nil {
		return err
	}
	buf := new(bytes.Buffer)
	if err = t.Execute(buf, data); err != nil {
		return err
	}
	r.body = buf.String()
	return nil
}

func NewRequest(to []string, subject, body string) *Request {
	return &Request{
		to:      to,
		subject: subject,
		body:    body,
	}
}

func NewEmailCommand() *cobra.Command {
	cmd := &cobra.Command{
		Use:   "email",
		Short: "A brief description of your command",
		Long:  "",
		Run: func(cmd *cobra.Command, args []string) {
			// path := strings.Replace(libre.Domain, ".", "-", -1)
			templateData := struct {
				Domain    string
				Password  string
				FirstName string
				LastName  string
			}{
				Password:  "p-t-n.fr",
				FirstName: "http://geektrust.in",
				LastName:  "http://geektrust.in",
			}
			r := NewRequest([]string{"gosselin.timothee@gmail.com"}, "Hello Junk!", "Hello, World!")

			if err := r.ParseTemplate("template.html", templateData); err != nil {
				fmt.Println(err)
				return
			}

			ok, err := r.SendEmail()
			if err != nil {
				fmt.Println(err)
				return
			}

			fmt.Println(ok)
			return
		},
	}

	return cmd
}
